/* generated by gtkcooker (http://www.nongnu.org/gtkcooker) */

#include <gtk/gtk.h>
#include "gui.h"

#include "jackend.h"
#include "power_buffer.h"
#include "defs.h"
#include "colors.h"
#include "gui_colors.h"
#include "fft_window.h"



#include "commands.h"

#include <stdint.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#define RED 0
#define GREEN 1
#define ORANGE 2

void gui_widget_show_all(void *d)
{
  gtk_widget_show_all(d);
}

void gui_state(mainwin *this)
{
  char s[4096];
  float dB, Hz;
  if (!(this->pointer_x >= 0 && this->pointer_x < this->width &&
      this->pointer_y >= 0 && this->pointer_y < this->height))
    Hz = -1;
  else {
    float *buf = power_buffer_get_line(&this->f, this->pointer_x);
    float f = R3(this->pointer_y, 0, this->height-1,
                 this->max_freq, this->min_freq);
    int pos = R3(f, 0, this->jack->sample_rate, 0, this->f.fft.n);
    Hz = R3(pos, 0, this->f.fft.n, 0, this->jack->sample_rate);
    dB = buf[pos];
  }
  if (Hz == -1)
    sprintf(s,
        "Hz [%g , %g] fft [%d/%d/%g%%%s] dB/t [%g , %g] dB/s [%g , %g] %s",
        this->min_freq, this->max_freq,
        this->f.to_process, this->f.fft.n, this->f.overlap*100,
        fft_window_string(&this->f.window),
        this->mindB_stats_overall,
        this->maxdB_stats_overall,
        this->mindB_stats_show,
        this->maxdB_stats_show,
        this->redraw_lines == redraw_lines_nearest ? "nearest" : "average");
  else
    sprintf(s,
"Hz [%g , %g] fft [%d/%d/%g%%%s] dB/t [%g , %g] dB/s [%g , %g] %s [%gHz %gdB]",
        this->min_freq, this->max_freq,
        this->f.to_process, this->f.fft.n, this->f.overlap*100,
        fft_window_string(&this->f.window),
        this->mindB_stats_overall,
        this->maxdB_stats_overall,
        this->mindB_stats_show,
        this->maxdB_stats_show,
        this->redraw_lines == redraw_lines_nearest ? "nearest" : "average",
        Hz, dB);
  gtk_label_set_text(GTK_LABEL(this->state_label), s);
  sprintf(s, "%-8.4g", this->colormap.mindB);
  gtk_label_set_text(GTK_LABEL(this->mindB_label), s);
  sprintf(s, "%-8.4g", this->colormap.maxdB);
  gtk_label_set_text(GTK_LABEL(this->maxdB_label), s);
}

void color_red(mainwin *this, unsigned long n)
{
  char s[64];
  PangoColor _pango_color;
  GdkColor _color;
  sprintf(s, "%lu", n);
  gtk_label_set_text(GTK_LABEL(this->color_label), s);
  if (this->current_color == RED) return;
  this->current_color = RED;
  if (pango_color_parse(&_pango_color, "#f00")) {
    _color.red = _pango_color.red;
    _color.green = _pango_color.green;
   _color.blue = _pango_color.blue;
    gtk_widget_modify_bg((GtkWidget *)this->color_label_draw,
                         GTK_STATE_NORMAL, &_color);
  }
}

void color_green(mainwin *this)
{
  PangoColor _pango_color;
  GdkColor _color;
  if (this->current_color == GREEN) return;
  this->current_color = GREEN;
  if (pango_color_parse(&_pango_color, "#0f0")) {
    _color.red = _pango_color.red;
    _color.green = _pango_color.green;
   _color.blue = _pango_color.blue;
    gtk_widget_modify_bg((GtkWidget *)this->color_label_draw,
                         GTK_STATE_NORMAL, &_color);
  }
  gtk_label_set_text(GTK_LABEL(this->color_label), "OK");
}

void color_orange(mainwin *this)
{
  PangoColor _pango_color;
  GdkColor _color;
  if (this->current_color == ORANGE) return;
  this->current_color = ORANGE;
  if (pango_color_parse(&_pango_color, "orange")) {
    _color.red = _pango_color.red;
    _color.green = _pango_color.green;
   _color.blue = _pango_color.blue;
    gtk_widget_modify_bg((GtkWidget *)this->color_label_draw,
                         GTK_STATE_NORMAL, &_color);
  }
  gtk_label_set_text(GTK_LABEL(this->color_label), "PAUSE");
}

void gui_init(void)
{
  gtk_init(0, 0);
}

void gui_quit(void)
{
  gtk_main_quit();
}

void gui_show(mainwin *w)
{
  gtk_widget_show_all(w->win);
}

void gui_run(void)
{
  gtk_main();
}

static void jack_callback(void *_this)
{
  unsigned long skipped = 0;
  mainwin *this = _this;
  int count = 0;
  int n;
  uint32_t ns;
  /* TODO: no partial read taken into account */
  while ((n = read(this->jack->jackfd, &ns, 4)) == 4) {
    count++;
    skipped += ns;
  }
  skipped -= ns;
  if (!(n == -1 && errno == EAGAIN)) { printf("read error\n"); exit(1); }
  if (count != 1) {
    this->lost_samples += skipped;
    color_red(this, this->lost_samples);
  }
  power_buffer_feed(&this->f, this->jack->buffer, ns);
}

static void power_new_line(void *_this)
{
  int j;
  mainwin *this = _this;
  float v;

  for (j = 0; j < this->height; j++) {
    memmove(this->image + j * this->width * 3,
            this->image + j * this->width * 3 + 3,
            (this->width-1) * 3);
  }

  this->redraw_lines(this, this->width-1, this->width-1);

  memmove(this->dsamples_min, this->dsamples_min+1, this->width-1);
  memmove(this->dsamples_max, this->dsamples_max+1, this->width-1);

  v = R3(this->f.buf_min, -1, 1, 0, 41);
  if (v < 0) v = 0;
  if (v > 41) v = 41;
  this->dsamples_min[this->width-1] = v;
  v = R3(this->f.buf_max, -1, 1, 0, 41);
  if (v < 0) v = 0;
  if (v > 41) v = 41;
  this->dsamples_max[this->width-1] = v;
  this->f.buf_min = 10000;
  this->f.buf_max = -10000;

  gui_state(this);
}

void gui_force_redraw(mainwin *this)
{
  gtk_widget_queue_draw(this->d);
  gtk_widget_queue_draw(this->dsamples);
}

void gui_force_redraw_colors(mainwin *this)
{
  gtk_widget_queue_draw(this->dcol);
}

static void redraw(mainwin *this)
{
  gdk_draw_rgb_image(GTK_WIDGET(this->d)->window,
      GTK_WIDGET(this->d)->style->black_gc, 0, 0, this->width, this->height,
      /* dith */ 0,
      this->image, this->width*3);
}

static void colors_redraw(mainwin *this)
{
  gdk_draw_rgb_image(GTK_WIDGET(this->dcol)->window,
      GTK_WIDGET(this->d)->style->black_gc, 0, 0, 10, this->col_height,
      /* dith */ 0,
      this->colors_image, 10*3);
}

static void dsamples_redraw(mainwin *this)
{
  int i;
  for (i = 0; i < this->width; i++) {
    gdk_draw_line(GTK_WIDGET(this->dsamples)->window,
                  GTK_WIDGET(this->dsamples)->style->fg_gc[GTK_STATE_NORMAL],
                  i, this->dsamples_min[i],
                  i, this->dsamples_max[i]);
  }
}

void gui_pause_unpause(mainwin *this)
{
  this->jack->paused = 1 - this->jack->paused;
  if (this->jack->paused)
    color_orange(this);
  else {
    if (this->lost_samples)
      color_red(this, this->lost_samples);
    else
      color_green(this);
  }
}

static gboolean stats_timer(gpointer _this)
{
  mainwin *this = _this;
  if (this->f.mindB_stats == 10000) {
    this->mindB_stats_show = -1000;
    this->maxdB_stats_show = -1000;
  } else {
    this->mindB_stats_show = this->f.mindB_stats;
    this->maxdB_stats_show = this->f.maxdB_stats;
    if (this->mindB_stats_show < this->mindB_stats_overall)
      this->mindB_stats_overall = this->mindB_stats_show;
    if (this->maxdB_stats_show > this->maxdB_stats_overall)
      this->maxdB_stats_overall = this->maxdB_stats_show;
  }
  this->f.mindB_stats = 10000;
  this->f.maxdB_stats = -10000;
  gui_state(this);
  return TRUE;
}

static gboolean d_resize(GtkWidget *_widget, GdkEventConfigure *_event,
                         mainwin *this)
{
  int height = _event->height;
  int width = _event->width;
  if (height < 10) height = 10;
  if (width < 10) width = 10;
  if (height == this->height && width == this->width) return TRUE;
  free(this->image);
  this->image = malloc(width * height * 3);
  if (!this->image) { printf("oom\n"); exit(1); }
  if (width != this->width) {
    unsigned char *dsamples_min = malloc(width);
    unsigned char *dsamples_max = malloc(width);
    float *power = malloc(sizeof(float) * width * (this->f.fft.n/2+1));
    int i;
    int min_width;
    if (!dsamples_min || !dsamples_max || !power) { printf("oom\n"); exit(1); }
    memset(dsamples_min, 20, width);
    memset(dsamples_max, 20, width);
    min_width = width < this->width ? width : this->width;
    for (i = 0; i < min_width; i++) {
      dsamples_min[width-1 - i] = this->dsamples_min[this->width-1 - i];
      dsamples_max[width-1 - i] = this->dsamples_max[this->width-1 - i];
    }
    free(this->dsamples_min);
    free(this->dsamples_max);
    this->dsamples_min = dsamples_min;
    this->dsamples_max = dsamples_max;
    for (i = 0; i < width * (this->f.fft.n/2+1); i++)
      power[i] = -120;
    for (i = 0; i < min_width; i++) {
      memcpy(power + (width-1 - i) * (this->f.fft.n/2+1),
             power_buffer_get_line(&this->f, this->width-1 - i),
             sizeof(float) * (this->f.fft.n/2+1));
    }
    free(this->f.power);
    this->f.power = power;
    this->f.line = 0;
    this->f.width = width;
  }
  this->width = width;
  this->height = height;
  this->redraw_lines(this, 0, width-1);
  return TRUE;
}

static gboolean dcol_resize(GtkWidget *_widget, GdkEventConfigure *_event,
                            mainwin *this)
{
  int height = _event->height;
  if (height < 10) height = 10;
  if (height == this->col_height) return TRUE;
  this->col_height = height;
  free(this->colors_image);
  this->colors_image = malloc(this->col_height * 10 * 3);
  if (!this->colors_image) { printf("oom\n"); exit(1); }
  redraw_lines_colors(this);
  return TRUE;
}




#include <fcntl.h>

void repl(void *_this)
{
  mainwin *this = _this;
  char c[128];
  int l;
  memset(c, 0, 128);
  if (read(0, c, 127));
  l = strlen(c); if (!l) return;
  if (c[l-1] == '\n') c[l-1] = 0;
  do_command(this, c);
  printf("> "); fflush(stdout);
}

void init_repl(mainwin *w)
{
  long f;
  f = fcntl(0, F_GETFL); if (f == -1) exit(1);
  f |= O_NONBLOCK;
  if (fcntl(0, F_SETFL, f) == -1) exit(1);
  gtk_input_add_full(0, GDK_INPUT_READ, (GdkInputFunction)repl, 0, w, 0);
  printf("> "); fflush(stdout);
}


static void _1(GtkEntry *_widget, mainwin *this)
{
  {
    do_command(this, gtk_entry_get_text(GTK_ENTRY(this->command)));
    gtk_entry_set_text(GTK_ENTRY(this->command), "");
  }
}

static gboolean _2(GtkWidget *_widget, GdkEventExpose *_event, mainwin *this)
{
  int x = _event->area.x;
  int y = _event->area.y;
  int width = _event->area.width;
  int height = _event->area.height;
  
  { redraw(this); if (0) { height++; width++; x++; y++; } }
  return TRUE;
}

static gboolean _3(GtkWidget *_widget, GdkEventCrossing *_event, mainwin *this)
{
  int x = _event->x;
  int y = _event->y;
  
  { this->pointer_x = x; this->pointer_y = y; gui_state(this); }
  return TRUE;
}

static gboolean _4(GtkWidget *_widget, GdkEventCrossing *_event, mainwin *this)
{
  int x = _event->x;
  int y = _event->y;
  
  { this->pointer_x = -1; gui_state(this); if (0) { x++; y++; } }
  return TRUE;
}

static gboolean _5(GtkWidget *_widget, GdkEvent *_event, mainwin *this)
{
  int x;
  int y;
  GdkEventType type = _event->type;
  int button;
  switch (type) {
    default: return FALSE;
    case GDK_MOTION_NOTIFY:
      x = _event->motion.x;
      y = _event->motion.y;
      break;
    case GDK_BUTTON_PRESS:
    case GDK_2BUTTON_PRESS:
    case GDK_3BUTTON_PRESS:
    case GDK_BUTTON_RELEASE:
      x = _event->button.x;
      y = _event->button.y;
      button = _event->button.button;
      break;
  }
  
  {
    if (type == GDK_MOTION_NOTIFY) {
      this->pointer_x = x;
      this->pointer_y = y;
      gui_state(this);
      /* dirty hack begin */
      static int recur = 0;
      static volatile int sx, sy;
      sx = x;
      sy = y;
      if (recur) return TRUE;
      recur = 1;
      while (gtk_events_pending()) gtk_main_iteration();
      /* should test quit/change of state of GUI (hell, I hate this hack) */
      recur = 0;
      x = sx;
      y = sy;
      /* dirty hack end */
#if 0
      /* first version of hack, totally non-working */
      while (1) {
        GdkEvent *ev = gdk_event_get();
        if (ev == NULL) break;
        if (ev->type != GDK_MOTION_NOTIFY) {
          gdk_event_put(ev);
          gdk_event_free(ev);
          break;
        }
        x = ev->motion.x;
        y = ev->motion.y;
        gdk_event_free(ev);
      }
#endif
      gui_mouse_move(this, x, y);
      return TRUE;
    }
    if (type == GDK_BUTTON_RELEASE) { gui_mouse_unclick(this); return TRUE; }
    if (type == GDK_BUTTON_PRESS) {
      int modifier = _event->button.state;
      int has_shift = modifier & GDK_SHIFT_MASK;
      int has_control = modifier & GDK_CONTROL_MASK;
      gui_mouse_click(this, x, y, has_shift, has_control);
      return TRUE;
    }
  }
  return TRUE;
}

static gboolean _6(GtkWidget *_widget, GdkEventExpose *_event, mainwin *this)
{
  int x = _event->area.x;
  int y = _event->area.y;
  int width = _event->area.width;
  int height = _event->area.height;
  
  { colors_redraw(this); if (0) { height++;width++;x++;y++; } }
  return TRUE;
}

static gboolean _7(GtkWidget *_widget, GdkEvent *_event, mainwin *this)
{
  int x;
  int y;
  GdkEventType type = _event->type;
  int button;
  switch (type) {
    default: return FALSE;
    case GDK_MOTION_NOTIFY:
      x = _event->motion.x;
      y = _event->motion.y;
      break;
    case GDK_BUTTON_PRESS:
    case GDK_2BUTTON_PRESS:
    case GDK_3BUTTON_PRESS:
    case GDK_BUTTON_RELEASE:
      x = _event->button.x;
      y = _event->button.y;
      button = _event->button.button;
      break;
  }
  
  {
    if (type == GDK_MOTION_NOTIFY) {
      /* dirty hack begin */
      static int recur = 0;
      static volatile int sx, sy;
      sx = x;
      sy = y;
      if (recur) return TRUE;
      recur = 1;
      while (gtk_events_pending()) gtk_main_iteration();
      /* should test quit/change of state of GUI (hell, I hate this hack) */
      recur = 0;
      x = sx;
      y = sy;
      /* dirty hack end */
      gui_colors_mouse_move(this, x, y);
      return TRUE;
    }
    if (type == GDK_BUTTON_RELEASE) {
      gui_colors_mouse_unclick(this);
      return TRUE;
    }
    if (type == GDK_BUTTON_PRESS) {
      gui_colors_mouse_click(this, x, y);
      return TRUE;
    }
  }
  return TRUE;
}

static gboolean _8(GtkWidget *_widget, GdkEventExpose *_event, mainwin *this)
{
  int x = _event->area.x;
  int y = _event->area.y;
  int width = _event->area.width;
  int height = _event->area.height;
  
  { dsamples_redraw(this);if(0){height++;width++;x++;y++;}}
  return TRUE;
}

static gboolean _9(GtkWidget *_widget, GdkEvent *_event, mainwin *this)
{
  int x;
  int y;
  GdkEventType type = _event->type;
  int button;
  switch (type) {
    default: return FALSE;
    case GDK_MOTION_NOTIFY:
      x = _event->motion.x;
      y = _event->motion.y;
      break;
    case GDK_BUTTON_PRESS:
    case GDK_2BUTTON_PRESS:
    case GDK_3BUTTON_PRESS:
    case GDK_BUTTON_RELEASE:
      x = _event->button.x;
      y = _event->button.y;
      button = _event->button.button;
      break;
  }
  
  {
    if (type != GDK_BUTTON_PRESS) return TRUE;
    if (button == 3) {
      this->mindB_stats_overall = 10000;
      this->maxdB_stats_overall = -10000;
    } else if (button == 1) {
      if (this->jack->paused) return TRUE;
      this->lost_samples = 0;
      color_green(this);
    }
  }
  return TRUE;
}

/* returns -1 on error, 0 if everything is fine */
int init_mainwin(mainwin *this, jack_stuff *jack)
{
  GtkWidget *_0;
  GtkWidget *lb;
  GtkWidget *rb;
  GtkWidget *rb2;
  GtkWidget *color_label_box;
  GtkWidget *command_box;
  GtkWidget *_10;
  GtkWidget *_11;
  GtkWidget *_12;
  GtkWidget *_13;
  GtkWidget *_14;
  GtkWidget *_15;
  GtkWidget *_16;
  GtkWidget *_17;
  GtkWidget *_18;
  GtkWidget *_19;
  GtkWidget *_20;

  {
    if (default_colormap(&this->colormap) == -1) exit(1);
    this->jack = jack;
    this->image = malloc(1024*512*3);
    if (!this->image) { printf("oom\n"); exit(1); }
    memset(this->image, 0, 1024*512*3);
    this->colors_image = malloc(10*512*3);
    if (!this->colors_image) { printf("oom\n"); exit(1); }
    memset(this->colors_image, 0, 10*512*3);
    this->dsamples_min = malloc(1024);
    this->dsamples_max = malloc(1024);
    if (!this->dsamples_min || !this->dsamples_max) {printf("oom\n");exit(1);}
    memset(this->dsamples_min, 20, 1024);
    memset(this->dsamples_max, 20, 1024);
    power_buffer_init(&this->f, 1024, 8192, power_new_line, this, BARTLETT);
    this->width = 1024;
    this->height = 512;
    this->col_height = 512;
    this->min_freq = 0;
    this->max_freq = jack->sample_rate / 2;
    this->mouse_state = 0;
    this->mouse_colors_state = 0;
    this->lost_samples = 0;
    this->mindB_stats_show = -1000;
    this->maxdB_stats_show = -1000;
    this->mindB_stats_overall = 10000;
    this->maxdB_stats_overall = -10000;
    this->current_color = -1;
    this->colmap.shown = 0;
    this->redraw_lines = redraw_lines_nearest;
    this->pointer_x = -1;
    this->pointer_y = -1;
  }

  this->win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  {
    GdkGeometry _geo; _geo.min_width = _geo.min_height = 1;
    gtk_window_set_geometry_hints(GTK_WINDOW(this->win),
        (GtkWidget *)this->win, &_geo, GDK_HINT_MIN_SIZE);
  }
  _0 = gtk_vbox_new(FALSE, 0);
  lb = gtk_vbox_new(FALSE, 0);
  rb = gtk_vbox_new(FALSE, 0);
  rb2 = gtk_vbox_new(FALSE, 0);
  color_label_box = gtk_vbox_new(FALSE, 0);
  command_box = gtk_vbox_new(FALSE, 0);
  this->mindB_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->mindB_label), "");
  gtk_misc_set_alignment(GTK_MISC(this->mindB_label), 0.500000, 1.000000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)this->mindB_label, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->maxdB_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->maxdB_label), "");
  gtk_misc_set_alignment(GTK_MISC(this->maxdB_label), 0.500000, 0.000000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)this->maxdB_label, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->color_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->color_label), "");
  gtk_misc_set_alignment(GTK_MISC(this->color_label), 0.500000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("6");
    gtk_widget_modify_font((GtkWidget *)this->color_label, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->state_label = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->state_label), "");
  gtk_misc_set_alignment(GTK_MISC(this->state_label), 0.000000, 0.500000);
  this->command = gtk_entry_new();
  gtk_entry_set_text(GTK_ENTRY(this->command),
    "help (press enter)");
  gtk_widget_set_size_request((GtkWidget *)this->command, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 8");
    gtk_widget_modify_font((GtkWidget *)this->command, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->d = gtk_drawing_area_new();
  gtk_widget_add_events((GtkWidget *)this->d, 
    GDK_POINTER_MOTION_MASK|GDK_BUTTON_MOTION_MASK|
    GDK_BUTTON_PRESS_MASK|GDK_BUTTON_RELEASE_MASK);
  gtk_widget_add_events((GtkWidget *)this->d, 
    GDK_ENTER_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->d, 
    GDK_LEAVE_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->d, 
    GDK_KEY_PRESS_MASK);
  gtk_widget_set_size_request((GtkWidget *)this->d, 1024, 512);
  this->dcol = gtk_drawing_area_new();
  gtk_widget_add_events((GtkWidget *)this->dcol, 
    GDK_POINTER_MOTION_MASK|GDK_BUTTON_MOTION_MASK|
    GDK_BUTTON_PRESS_MASK|GDK_BUTTON_RELEASE_MASK);
  gtk_widget_add_events((GtkWidget *)this->dcol, 
    GDK_ENTER_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->dcol, 
    GDK_LEAVE_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->dcol, 
    GDK_KEY_PRESS_MASK);
  gtk_widget_set_size_request((GtkWidget *)this->dcol, 10, 512);
  this->dsamples = gtk_drawing_area_new();
  gtk_widget_add_events((GtkWidget *)this->dsamples, 
    GDK_POINTER_MOTION_MASK|GDK_BUTTON_MOTION_MASK|
    GDK_BUTTON_PRESS_MASK|GDK_BUTTON_RELEASE_MASK);
  gtk_widget_add_events((GtkWidget *)this->dsamples, 
    GDK_ENTER_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->dsamples, 
    GDK_LEAVE_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->dsamples, 
    GDK_KEY_PRESS_MASK);
  gtk_widget_set_size_request((GtkWidget *)this->dsamples, 1024, 41);
  this->color_label_draw = gtk_drawing_area_new();
  gtk_widget_add_events((GtkWidget *)this->color_label_draw, 
    GDK_POINTER_MOTION_MASK|GDK_BUTTON_MOTION_MASK|
    GDK_BUTTON_PRESS_MASK|GDK_BUTTON_RELEASE_MASK);
  gtk_widget_add_events((GtkWidget *)this->color_label_draw, 
    GDK_ENTER_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->color_label_draw, 
    GDK_LEAVE_NOTIFY_MASK);
  gtk_widget_add_events((GtkWidget *)this->color_label_draw, 
    GDK_KEY_PRESS_MASK);
  gtk_widget_set_size_request((GtkWidget *)this->color_label_draw, 40, 20);
  _10 = gtk_hbox_new(FALSE, 4);
  _11 = gtk_hbox_new(FALSE, 0);
  _12 = gtk_hbox_new(FALSE, 0);
  _13 = gtk_hbox_new(FALSE, 0);
  _14 = gtk_hbox_new(FALSE, 0);
  _15 = gtk_hbox_new(FALSE, 0);
  _16 = gtk_hbox_new(FALSE, 0);
  _17 = gtk_hbox_new(FALSE, 0);
  _18 = gtk_hbox_new(FALSE, 0);
  _19 = gtk_hbox_new(FALSE, 0);
  _20 = gtk_hbox_new(FALSE, 0);

  gtk_container_add(GTK_CONTAINER(this->win), (GtkWidget *)_0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_10, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_0), (GtkWidget *)_11, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(lb), (GtkWidget *)_12, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(lb), (GtkWidget *)_13, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(rb), (GtkWidget *)_14, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(rb), (GtkWidget *)_15, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(rb2), (GtkWidget *)_16, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(rb2), (GtkWidget *)_17, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(color_label_box), (GtkWidget *)_18, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(color_label_box), (GtkWidget *)_19, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(command_box), (GtkWidget *)_20, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_10), (GtkWidget *)lb, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_10), (GtkWidget *)rb, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_11), (GtkWidget *)this->state_label, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_11), (GtkWidget *)command_box, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_12), (GtkWidget *)this->d, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_13), (GtkWidget *)this->dsamples, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_14), (GtkWidget *)this->dcol, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_14), (GtkWidget *)rb2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_15), (GtkWidget *)color_label_box, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_16), (GtkWidget *)this->maxdB_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_17), (GtkWidget *)this->mindB_label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_18), (GtkWidget *)this->color_label_draw, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_19), (GtkWidget *)this->color_label, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_20), (GtkWidget *)this->command, FALSE, FALSE, 0);


  this->command_activate = g_signal_connect(this->command, "activate", G_CALLBACK(_1), this);

  this->d_expose = g_signal_connect(this->d, "expose-event", G_CALLBACK(_2), this);
  this->d_enter = g_signal_connect(this->d, "enter-notify-event", G_CALLBACK(_3), this);
  this->d_leave = g_signal_connect(this->d, "leave-notify-event", G_CALLBACK(_4), this);
  this->d_pointer_motion = g_signal_connect(this->d, "motion-notify-event", G_CALLBACK(_5), this);
  this->d_pointer_press = g_signal_connect(this->d, "button-press-event", G_CALLBACK(_5), this);
  this->d_pointer_release = g_signal_connect(this->d, "button-release-event", G_CALLBACK(_5), this);

  this->dcol_expose = g_signal_connect(this->dcol, "expose-event", G_CALLBACK(_6), this);
  this->dcol_pointer_motion = g_signal_connect(this->dcol, "motion-notify-event", G_CALLBACK(_7), this);
  this->dcol_pointer_press = g_signal_connect(this->dcol, "button-press-event", G_CALLBACK(_7), this);
  this->dcol_pointer_release = g_signal_connect(this->dcol, "button-release-event", G_CALLBACK(_7), this);

  this->dsamples_expose = g_signal_connect(this->dsamples, "expose-event", G_CALLBACK(_8), this);

  this->color_label_draw_pointer_motion = g_signal_connect(this->color_label_draw, "motion-notify-event", G_CALLBACK(_9), this);
  this->color_label_draw_pointer_press = g_signal_connect(this->color_label_draw, "button-press-event", G_CALLBACK(_9), this);
  this->color_label_draw_pointer_release = g_signal_connect(this->color_label_draw, "button-release-event", G_CALLBACK(_9), this);

  {
    this->jack_callback = gtk_input_add_full(jack->jackfd, GDK_INPUT_READ,
                              (GdkInputFunction)jack_callback, 0, this, 0);
    init_repl(this);
    color_green(this);
    gui_state(this);
    g_timeout_add(1000, stats_timer, this);
    g_signal_connect(this->d, "configure-event", G_CALLBACK(d_resize), this);
    g_signal_connect(this->dcol, "configure-event",
                     G_CALLBACK(dcol_resize), this);
    redraw_lines_colors(this);
    this->redraw_lines(this, 0, this->width-1);
    strcpy(this->colmap.curdir, DEF_COLORMAP_DIR);
  }

  return 0;
}

